<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.yiqi.order.mapper.OrderPurchaseGoodsSkuMapper">

    <resultMap type="OrderPurchaseGoodsSku" id="OrderPurchaseGoodsSkuResult">
        <result property="id" column="id"/>
        <result property="orderId" column="order_id"/>
        <result property="orderPurchaseGoodsItemId" column="order_purchase_goods_item_id"/>
        <result property="buyNum" column="buy_num"/>
        <result property="costPrice" column="cost_price"/>
        <result property="skuName" column="sku_name"/>
        <result property="skuId" column="sku_id"/>
        <result property="goodsId" column="goods_id"/>
        <result property="createById" column="create_by_id"/>
        <result property="createBy" column="create_by"/>
        <result property="createTime" column="create_time"/>
        <result property="updateById" column="update_by_id"/>
        <result property="updateBy" column="update_by"/>
        <result property="updateTime" column="update_time"/>
        <result property="remark" column="remark"/>
    </resultMap>

    <sql id="selectOrderPurchaseGoodsSkuVo">
        select id, order_id, order_purchase_goods_item_id, buy_num, cost_price, sku_name, sku_id, goods_id, create_by_id, create_by, create_time, update_by_id, update_by, update_time, remark
        from order_purchase_goods_sku
    </sql>

    <select id="selectOrderPurchaseGoodsSkuList" parameterType="OrderPurchaseGoodsSku" resultMap="OrderPurchaseGoodsSkuResult">
        <include refid="selectOrderPurchaseGoodsSkuVo"/>
        <where>
            <if test="orderId != null ">
                and order_id = #{orderId}
            </if>
            <if test="orderPurchaseGoodsItemId != null ">
                and order_purchase_goods_item_id = #{orderPurchaseGoodsItemId}
            </if>
            <if test="buyNum != null ">
                and buy_num = #{buyNum}
            </if>
            <if test="costPrice != null ">
                and cost_price = #{costPrice}
            </if>
            <if test="skuName != null  and skuName != ''">
                and sku_name like concat('%', #{skuName}, '%')
            </if>
            <if test="skuId != null ">
                and sku_id = #{skuId}
            </if>
            <if test="goodsId != null ">
                and goods_id = #{goodsId}
            </if>
        </where>
    </select>

    <select id="selectOrderPurchaseGoodsSkuById" parameterType="Long"
            resultMap="OrderPurchaseGoodsSkuResult">
        <include refid="selectOrderPurchaseGoodsSkuVo"/>
        where id = #{id}
    </select>

    <insert id="insertOrderPurchaseGoodsSku" parameterType="OrderPurchaseGoodsSku" useGeneratedKeys="true"
            keyProperty="id">
        insert into order_purchase_goods_sku
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="orderId != null">order_id,
            </if>
            <if test="orderPurchaseGoodsItemId != null">order_purchase_goods_item_id,
            </if>
            <if test="buyNum != null">buy_num,
            </if>
            <if test="costPrice != null">cost_price,
            </if>
            <if test="skuName != null">sku_name,
            </if>
            <if test="skuId != null">sku_id,
            </if>
            <if test="goodsId != null">goods_id,
            </if>
            <if test="createById != null">create_by_id,
            </if>
            <if test="createBy != null">create_by,
            </if>
            <if test="createTime != null">create_time,
            </if>
            <if test="updateById != null">update_by_id,
            </if>
            <if test="updateBy != null">update_by,
            </if>
            <if test="updateTime != null">update_time,
            </if>
            <if test="remark != null">remark,
            </if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="orderId != null">#{orderId},
            </if>
            <if test="orderPurchaseGoodsItemId != null">#{orderPurchaseGoodsItemId},
            </if>
            <if test="buyNum != null">#{buyNum},
            </if>
            <if test="costPrice != null">#{costPrice},
            </if>
            <if test="skuName != null">#{skuName},
            </if>
            <if test="skuId != null">#{skuId},
            </if>
            <if test="goodsId != null">#{goodsId},
            </if>
            <if test="createById != null">#{createById},
            </if>
            <if test="createBy != null">#{createBy},
            </if>
            <if test="createTime != null">#{createTime},
            </if>
            <if test="updateById != null">#{updateById},
            </if>
            <if test="updateBy != null">#{updateBy},
            </if>
            <if test="updateTime != null">#{updateTime},
            </if>
            <if test="remark != null">#{remark},
            </if>
        </trim>
    </insert>

    <update id="updateOrderPurchaseGoodsSku" parameterType="OrderPurchaseGoodsSku">
        update order_purchase_goods_sku
        <trim prefix="SET" suffixOverrides=",">
            <if test="orderId != null">order_id =
                #{orderId},
            </if>
            <if test="orderPurchaseGoodsItemId != null">order_purchase_goods_item_id =
                #{orderPurchaseGoodsItemId},
            </if>
            <if test="buyNum != null">buy_num =
                #{buyNum},
            </if>
            <if test="costPrice != null">cost_price =
                #{costPrice},
            </if>
            <if test="skuName != null">sku_name =
                #{skuName},
            </if>
            <if test="skuId != null">sku_id =
                #{skuId},
            </if>
            <if test="goodsId != null">goods_id =
                #{goodsId},
            </if>
            <if test="createById != null">create_by_id =
                #{createById},
            </if>
            <if test="createBy != null">create_by =
                #{createBy},
            </if>
            <if test="createTime != null">create_time =
                #{createTime},
            </if>
            <if test="updateById != null">update_by_id =
                #{updateById},
            </if>
            <if test="updateBy != null">update_by =
                #{updateBy},
            </if>
            <if test="updateTime != null">update_time =
                #{updateTime},
            </if>
            <if test="remark != null">remark =
                #{remark},
            </if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteOrderPurchaseGoodsSkuById" parameterType="Long">
            delete from order_purchase_goods_sku where id = #{id}
        </delete>

    <delete id="deleteOrderPurchaseGoodsSkuByIds" parameterType="String">
        delete from order_purchase_goods_sku where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>



</mapper>